#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <math.h>
#include "menu.h"
#include "BigInteger.h"
#include <conio.h>

using namespace std;

#define R_NUMBER 1000

__int64  plain_text, cryptogram;
__int64  E,D,p,q;
__int64 N,L;


int mod(int E, int N);
int Random_p_q();
int isPrime();
__int64  l_lcm(__int64 data1,__int64 data2);
int e_gcm(int L);
int encryption(__int64 E, __int64 N);
void public_key_generation();
void individual_key_generation();
void decryption();

int main()
{
    int choice;
    srand(time(NULL));
    while(1){
        print_menu();
        scanf("%d",&choice);
        switch(choice){
            case 1: //public generation
            public_key_generation();
             break;

             case 2:
             individual_key_generation();
             break;

             case 3:
             E=e_gcm(L);
             break;

             case 4:
             printf("public     key --> (E , N)=(%lld, %lld)\n",E,N);
             printf("individual key --> (D , N)=(%lld, %lld)\n",D,N);
             break;

             case 5:
             encryption(E,N);
             break;

             case 6:
             decryption();
             break;

			 case 7:
				 break;

             case 9:
             printf("bye bye \n");
             return 0;
        }
    }
}

int mod(int E, int N)
{
    int mod=0;
    mod=E%N;
    return mod;
}
int Random_p_q()
{
    int random_num;

    random_num=rand()%R_NUMBER+2;
    return random_num;
}
int isPrime()
{
    printf("isPrime start \n");
    int i=2;
    int Prime=0,n=0,check=0;
    while(1)
	{
		n=Random_p_q();
		if(n % 2 != 0)//홀수일 경우만 진행
		{
			for(i; i<n; i++){
				if(n%i==0){
                 check++;//check 가 1이상이면 짝수기 때문
				// printf("prime check = %d \n",check);
                // printf("                      check=%d\n",check);
				}
            //printf("Random_p_q = %d i=%d \n",n,i);
			}
			//check 가 0이여야만 소수임
			if(check==0){
				//printf("prime ok=%d \n",n);
				Prime=n;
				break;
			}
			else if(check>=1){
            //printf("prime false \n");
            check=0,i=2;
			}
		}
	}
	return Prime;
}

__int64 l_lcm(__int64 data1,__int64 data2)
{
    printf("l_lcm start p = %lld q = %lld \n",data1,data2);
    __int64 i;
    __int64 gcm=0,lcm=0;
    __int64  maxdata,mindata;

    if(data1 > data2){
    maxdata=data1-1;
    mindata=data2-1;
    }else{
    maxdata=data2-1;
    mindata=data1-1;
    }

    for(i = 1; i <= mindata; i++) {
        if( mindata%i==0 && maxdata%i==0) {
            gcm=i;
           // printf("%d와 %d의 최소공배수는 %d입니다\n",maxdata,mindata,maxdata*i);
            break;
        }
    }
    lcm=gcm*(mindata/gcm)*(maxdata/gcm);
    return lcm;
}

int e_gcm(int tmp)
{
	printf("e_gcm start \n");
	__int64 *arCandidate;
    if(L==0){
        printf("creat key generation \n");
        return 0;
    }
    int i,j;
    __int64 count=0;
    __int64 random_count=0;
    int E=0;
	arCandidate=(__int64 *)malloc(L*sizeof(__int64));
    //__int64 arCandidate[ARR]={0};
    printf("L=%d\n",tmp);
    for(i=1;i<tmp;i++){
        if(tmp%i==0){
            //printf("count ====== %lld \n",count);
            //printf("%d %d = not gcm\n",m,i);
        }else{
           arCandidate[count]=i;
           //printf("count = %lld \n",count);
           count++;
           //printf("%d / %d gcm Candidate \n",tmp,i);
        }
    }
    for(j=0;j<=count;j++)
    {
        //printf("E %d address candidate=%lld \n",j,arCandidate[j]);
    }
    printf("candidate count = %lld \n",count);
    random_count=rand()%count;
    E=arCandidate[random_count];
    printf("random_count = %lld \n",random_count);
    printf("E=%lld \n",arCandidate[random_count]);
	free(arCandidate);
    return E;
}

int encryption(__int64 E, __int64 N)
{
    if(E == 0 || N == 0){
        printf("key generater \n");
        return 0;
    }
    int ptext=0;
    __int64 tmp=0,   arPow_tmp=0, arResult=0, remainder=0;
    printf("input planin text \n");
    scanf("%d",&ptext);
	
	//평문이 E 보다 작은값이여야함
	if(ptext>=E){
		printf("ptext is E < \n");
		 return 0;
	}

	BigInteger ptext_pow1(ptext);
	BigInteger ptext_pow2(ptext);

	//평문의 제곱근 계산
	 for(int i=2 ; i<=E ; i++){
		 ptext_pow2=ptext_pow1*ptext_pow2;				 
		 //cout << i << "=" << pow2 << endl;
	 }
	 cout << ptext_pow2 << endl;
	 /*
	//5로 나누어 제곱근 연산
    __int64 arPow[10000]={0,};
    arResult=E / 5;
    remainder=E % 5;
    for(int i = 0 ; i <arResult ; i++){
		arPow_tmp=pow((int)ptext,5.0);
        arPow[i]=arPow_tmp % N;
        printf("arPow %lld \n",arPow[i]);
        if(i==arResult -1 ){
            arPow_tmp = pow((int)ptext,(double)remainder);
            arPow[i+1] = arPow_tmp % N;
            printf("arPow %lld \n",arPow[i+1]);
        }
    } 
	*/
	////////////////////////

    //tmp=pow((__int64)arPow[0],(double)arResult);
    //printf("tmp = %lld \n",tmp);
    //cryptogram=tmp*arPow[(__int64)arResult];
    //printf("cryptogram = %d \n",cryptogram);


    //tmp=pow(ptext,E);
    cryptogram=ptext_pow2%N;
    //printf("plain text = %d  E= %lld N= %lld\n",ptext,E,N);
    //printf("plantext ^ E = %lld \n",tmp);
    printf("cryptogram = %d \n",cryptogram);

    return 0;
}

void public_key_generation()
{
    p=isPrime();
    q=isPrime();
    N=p*q;
    L=l_lcm(p,q);
    printf("\n p=%lld q=%lld p*q=%lld(N) L=%lld \n",p,q,N,L);
    E=e_gcm(L);

}

void individual_key_generation()
{
    __int64 tmp_d=0,result=0;
    for(tmp_d=2 ; tmp_d<N ; tmp_d++){
        result=(E * tmp_d) % L;
        //printf(" (%lld * %lld) = %lld  /  %lld = %lld \n",E,tmp_d,E*tmp_d,L,result);
        if( result== 1){
            D=tmp_d;
            printf("D == %lld",D);
            break;
        }
    }
	if(D==0){
		printf("not D \n");
	}
}

void decryption()
{
	BigInteger cryptogram_pow1(cryptogram);
	BigInteger cryptogram_pow2(cryptogram);
	 for(int i=2 ; i<=D ; i++){
		 cryptogram_pow2=cryptogram_pow1*cryptogram_pow2;				 
		 //cout << D-i << "======================" << cryptogram_pow2 << endl;
		 //getch();
	 }
    plain_text=cryptogram_pow2 % N;
    printf("decryptoin = %d \n",plain_text);
}
