/*
 * ׽Ʈ ڵ Դϴ.
 * BigInteger  , Լ ׽Ʈ Ͽϴ.
 * ׽Ʈ ϳ  ð 0.2ʷ  ªϴ.
 *   õõ  е
 * Ʒ
 * #define SHOW_TIME 200
 *  ڸ Ͽ  ٶϴ.
 */


#include <iostream>
#include <string>
using namespace std;
#include "BigInteger.h"
#include <Windows.h>

#define SHOW_TIME 200
#define  PRINT_TEST_MESSASE(str) { \
Sleep(SHOW_TIME); \
system("cls"); \
cout << __COUNTER__ << "° ׽Ʈ ǽ մϴ." << endl; \
cout << '<' << str << '>' << "   ׽Ʈ ǽ մϴ." << endl; \
Sleep(SHOW_TIME); \
}

#define TEST(expr) { \
cout << "[Line " << __LINE__ << "]  "; \
try { \
cout << "  [ " <<(#expr) << " ]  [  "; \
cout << (expr) << "  ]  "; \
cout <<	"   [!!!]"; \
Sleep(SHOW_TIME); \
} \
catch (const char * err) { \
cout << " Դϴ.  : " << err; \
Sleep(SHOW_TIME); \
}; \
cout << endl; \
}

int main()
{
	BigInteger zero(0), one(1), ten(10);
	const BigInteger c_zero(0), c_one(-1), c_ten(-10);

	bool b = false;
	const bool cb = true;

	unsigned char uc = 2;
	char c = 3;
	const unsigned char cuc = 4;
	const char cc = 5;

	unsigned short us = 6;
	short s = 7;
	const unsigned short cus = 8;
	const short cs = 9;

	unsigned long ul = 10;
	long l = 11;
	const unsigned long cul = 12;
	const long cl = 13;

	unsigned int ui = 14;
	int i = 15;
	const unsigned int cui = 16;
	const int ci = 17;

	unsigned __int64 ui64 = 18;
	__int64 i64 = 19;
	const unsigned __int64 cui64 = 20;
	const __int64 ci64 = 21;

	try
	{
		
		PRINT_TEST_MESSASE("⺻ ");
		TEST(BigInteger()); // 0
		
		PRINT_TEST_MESSASE(" ");
		TEST(BigInteger(zero)); // 0
		TEST(BigInteger(one)); // 1
		TEST(BigInteger(ten)); // 10
		TEST(BigInteger(c_zero)); // 0
		TEST(BigInteger(c_one)); // -1
		TEST(BigInteger(c_ten)); // -10

		PRINT_TEST_MESSASE(" ");
		BigInteger test_assign;
		TEST(test_assign = zero); // 0
		TEST(test_assign = one); // 1
		TEST(test_assign = ten); // 10
		TEST(test_assign = c_zero); // 0
		TEST(test_assign = c_one); // -1
		TEST(test_assign = c_ten); // -10

		PRINT_TEST_MESSASE("ø  (⺻)");
		TEST(test_assign = b); // 0
		TEST(test_assign = cb); // 1
		TEST(test_assign = uc); // 2
		TEST(test_assign = c); // 3
		TEST(test_assign = cuc); // 4
		TEST(test_assign = cc); // 5
		TEST(test_assign = us); // 6
		TEST(test_assign = s); // 7
		TEST(test_assign = cus); // 8
		TEST(test_assign = cs); // 9
		TEST(test_assign = ul); // 10
		TEST(test_assign = l); // 11
		TEST(test_assign = cul); // 12
		TEST(test_assign = cl); // 13
		TEST(test_assign = ui); // 14
		TEST(test_assign = i); // 15
		TEST(test_assign = cui); // 16
		TEST(test_assign = ci); // 17
		TEST(test_assign = ui64); // 18
		TEST(test_assign = i64); // 19
		TEST(test_assign = cui64); // 20
		TEST(test_assign = ci64); // 21

		PRINT_TEST_MESSASE("ȯ ()");
		TEST(BigInteger(b)); // 0
		TEST(BigInteger(cb)); // 1
		TEST(BigInteger(uc)); // 2
		TEST(BigInteger(c)); // 3
		TEST(BigInteger(cuc)); // 4
		TEST(BigInteger(cc)); // 5
		TEST(BigInteger(us)); // 6
		TEST(BigInteger(s)); // 7
		TEST(BigInteger(cus)); // 8
		TEST(BigInteger(cs)); // 9
		TEST(BigInteger(ul)); // 10
		TEST(BigInteger(l)); // 11
		TEST(BigInteger(cul)); // 12
		TEST(BigInteger(cl)); // 13
		TEST(BigInteger(ui)); // 14
		TEST(BigInteger(i)); // 15
		TEST(BigInteger(cui)); // 16
		TEST(BigInteger(ci)); // 17
		TEST(BigInteger(ui64)); // 18
		TEST(BigInteger(i64)); // 19
		TEST(BigInteger(cui64)); // 20
		TEST(BigInteger(ci64)); // 21
		
		PRINT_TEST_MESSASE("ȯԼ");
		TEST(BigInteger(0).operator bool()); // 0
		TEST(BigInteger(1).operator bool()); // 1
		TEST(BigInteger(-1).operator bool()); // 1
		// char, short, long, __int64 ...(  )
		TEST(BigInteger(1).operator int()); // 1
		TEST(BigInteger(1).operator unsigned int()); // 1
		TEST(BigInteger(0).operator int()); // 0
		TEST(BigInteger(0).operator unsigned int()); // 0
		TEST(BigInteger(-1).operator int()); // -1
		TEST(BigInteger(-1).operator unsigned int()); // error
		TEST(BigInteger(0xFFFFFFFF).operator int()); // error
		TEST(BigInteger(0xFFFFFFFF).operator unsigned int()); // 4294967295
		TEST(BigInteger(0x100000000).operator unsigned int()); // error

		PRINT_TEST_MESSASE("ڿ  ȯ");
		char *test_char = "1234";
		string test_string = "5678";
		TEST(BigInteger(test_char)); // 1234
		TEST(BigInteger(test_string)); // 5678
		TEST(BigInteger("0")); // 0
		TEST(BigInteger("-0")); // 0
		TEST(BigInteger("00000000000000000000000000000000001")); // 1
		TEST(BigInteger("-1")); // -1
		TEST(BigInteger("abcd")); // 0
		TEST(BigInteger("0101011")); // 101011
		TEST(BigInteger("1234a")); // 1234
		TEST(BigInteger("1aaaaaaaaaaaaaaaaaa2")); // 0
		BigInteger test_str;
		string test_input_str;
		for (int temp_i = 0; temp_i <=37; ++temp_i)
		{
			TEST(test_str.stob("10", temp_i)); // 2 ~ 36
			TEST(test_input_str = test_str.btos(temp_i)); // 10
		}

		PRINT_TEST_MESSASE("ǥ  ׽Ʈ");
		BigInteger test_input_output;
		cout << " Է ʿմϴ." << endl;
		cout << "ƹ ڳ Էϼ.(, 10 Է) : ";
		cin >> test_input_output;
		cout << "8 : ";
		cout << oct << test_input_output << endl;
		cout << "10 : ";
		cout << dec << test_input_output << endl;
		cout << "16 : ";
		cout << hex << test_input_output << endl;
		Sleep(SHOW_TIME);
		cout << "ȣ 0x, 0 ǥõ˴ϴ." << endl;
		cout.setf(ios_base::showpos);
		cout.setf(ios_base::showbase);
		Sleep(SHOW_TIME);
		cout << "8 : ";
		cout << oct << test_input_output << endl;
		cout << "10 : ";
		cout << dec << test_input_output << endl;
		cout << "16 : ";
		cout << hex << test_input_output << endl;
		Sleep(SHOW_TIME);
		cout.unsetf(ios_base::showpos);
		cout.unsetf(ios_base::showbase);
		cout.setf(ios_base::dec);
		
		PRINT_TEST_MESSASE("  ׽Ʈ");
		TEST(one == zero); // 0
		TEST(one != zero); // 1
		TEST(one > c_one); // 1
		TEST(c_ten >= ten); // 0
		TEST(c_zero < one); // 1
		TEST(c_one <= c_ten); // 0
		TEST(one == cb); // 1
		TEST(ul == ten); // 1
		
		PRINT_TEST_MESSASE("Ʈ  ׽Ʈ");
		TEST(zero.bitlength()); // 0
		TEST(one.bitlength()); // 1
		TEST(ten.bitlength()); // 4
		TEST(c_zero.bitlength()); // 0
		TEST(c_one.bitlength()); // 1
		TEST(c_ten.bitlength()); // 4
		BigInteger test_bitcalc;
		TEST(ten & BigInteger(2)); // 2
		TEST(ten & c_ten); // 10
		TEST(c_ten & BigInteger(-2)); // -2
		test_bitcalc = 3;
		TEST(test_bitcalc &= one); // 1
		TEST(test_bitcalc &= c_one); // 1
		TEST(ten | BigInteger(2)); // 10
		TEST(ten | c_ten); // -10
		TEST(c_ten | BigInteger(-2)); // -10
		test_bitcalc = 3;
		TEST(test_bitcalc |= one); // 3
		TEST(test_bitcalc |= c_one); // -3
		TEST(ten ^ BigInteger(2)); // 8
		TEST(ten ^ c_ten); // 0
		TEST(c_ten ^ BigInteger(-2)); // 8
		test_bitcalc = 3;
		TEST(test_bitcalc ^= one); // 2
		TEST(test_bitcalc ^= c_one); // -3
		TEST(~zero); // -1
		TEST(~one); // -2
		TEST(~ten); // -11
		TEST(~c_zero); // -1
		TEST(~c_one); // 0
		TEST(~c_ten); // 9
		TEST(ten & cb); // 0
		TEST(c_ten & cus); // 8
		TEST(i64 & BigInteger(15)); // 3
		TEST(cui64 & BigInteger(15)); // 4
		int test_bitcalc_assign = 3;
		TEST(test_bitcalc_assign &= one); // 1
		test_bitcalc_assign = 3;
		TEST(test_bitcalc_assign &= BigInteger(0xFFFFFFFFF)); // 3
		TEST(test_bitcalc_assign |= BigInteger(0xFFFFFFFFF)); // error
		TEST(test_bitcalc_assign ^= BigInteger(0xFFFFFFFFF)); // error
		
		PRINT_TEST_MESSASE("Ʈ  ׽Ʈ")
		TEST(zero << 1); // 0
		TEST(one << 1); // 2
		TEST(ten << 1); // 20
		TEST(c_zero << 1); // 0
		TEST(c_one << 1); // -2
		TEST(c_ten << 1); // -20
		TEST(one << BigInteger(0x100000000)); // error
		TEST(ten >> one); // 5
		TEST(ten >> int(cc)); // 0
		
		PRINT_TEST_MESSASE("Ģ// ׽Ʈ");
		TEST(-zero); // 0
		TEST(-one); // -1
		TEST(-ten); // -10
		TEST(-c_zero); // 0
		TEST(-c_one); // 1
		TEST(-c_ten); // 10
		TEST(abs(zero)); // 0
		TEST(abs(one)); // 1
		TEST(abs(c_one)); // 1
		TEST(abs(c_ten)); // 10
		TEST(one + c_one); // 0
		TEST(c_zero + ten); // 10
		BigInteger test_4calc_oper;
		TEST(test_4calc_oper += c_ten); // -10
		TEST(test_4calc_oper - c_zero); // -10
		TEST(ten * c_ten); // -100
		TEST(test_4calc_oper * zero); // 0
		TEST(ten / BigInteger(2)); // 5
		TEST(ten / BigInteger(-2)); // -5
		TEST(c_ten / BigInteger(2)); // -5
		TEST(c_ten / BigInteger(-2)); // 5
		TEST(one / zero); // error
		TEST(ten % BigInteger(2)); // 0
		TEST(ten % BigInteger(3)); // 1
		TEST(one % one); // 0
		TEST(one % zero); // error
		test_4calc_oper = 15;
		TEST(test_4calc_oper /= BigInteger(2)); // 7
		TEST(test_4calc_oper %= BigInteger(2)); // 1
		TEST(one + cus); // 9
		TEST(one - cus); // -7
		TEST(one * cus); // 8
		TEST(one / cus); // 0
		TEST(cus + one); // 9
		TEST(cus - one); // 7
		TEST(cus * one); // 8
		TEST(cus / one); // 8
		test_4calc_oper = 5;
		TEST(test_4calc_oper += us); // 11
		TEST(test_4calc_oper -= us); // 5
		TEST(test_4calc_oper *= us); // 30
		TEST(test_4calc_oper /= us); // 5
		int test_4calc_assign = 4;
		TEST(test_4calc_assign += us); // 10
		TEST(test_4calc_assign -= us); // 4
		TEST(test_4calc_assign *= us); // 24
		TEST(test_4calc_assign /= us); // 4
		TEST(test_4calc_assign += BigInteger(0x100000000)); // error
		BigInteger test_pp_oper;
		TEST(++test_pp_oper); // 1
		TEST(++++test_pp_oper); // 3
		TEST(test_pp_oper++); // 3
		TEST(--test_pp_oper); // 3
		TEST(----test_pp_oper); // 1
		TEST(test_pp_oper--); // 1
		TEST(--test_pp_oper); // -1
		
		PRINT_TEST_MESSASE("Ÿ  ׽Ʈ");
		pow(ten, ten);
		TEST(pow(ten, ten)); // 10^10
		TEST(pow(ten, zero)); // 1
		TEST(pow(ten, c_one)); // error
		TEST(pow(c_ten, 20)); // 10^20 ????
		TEST(pow(10, ten)); // 10^10
		TEST(pow(zero, zero)); // error
		TEST(pow(zero, one)); // 0
		TEST(factorial(zero)); // 1
		TEST(factorial(one)); // 1
		TEST(factorial(ten)); // 3628800
		TEST(factorial(c_zero)); // 1
		TEST(factorial(c_one)); // -1
		TEST(factorial(c_ten)); // -3628800
		TEST(gcd(ten, BigInteger(4))); // 2
		TEST(gcd(c_ten, BigInteger(4))); // error
		TEST(gcd(0, BigInteger(4))); // 0
		TEST(lcm(ten, BigInteger(4))); // 20
		TEST(lcm(c_ten, BigInteger(4))); // error
		TEST(lcm(0, BigInteger(4))); // 0
		
		PRINT_TEST_MESSASE("ū  ׽Ʈ");
		BigInteger bigint;
		TEST(bigint = one << 1000); // 2 ^ 1000
		TEST(bigint + bigint); // 2 ^ 1001
		TEST(bigint * bigint); // 2 ^ 2000
		TEST(factorial(BigInteger(500)));
	}
	catch (const char* e)
	{
		cout << "Uncatched Error !!! : " << e << endl;
	}

	return 0;
}
